function quiz = sdmclear(quiz)
% SDMCLEAR - clear the previous solution of the problem if necessary
%
%   For internal use only!
 
%   This file is part of SeDuMi Interface 1.04 (JUL2002)
%   Last Update 17th July 2002 
%   Copyright (C) 2002 Dimitri Peaucelle & Krysten Taitz
%   LAAS-CNRS, Toulouse, France
% 
%   This program is free software; you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation; either version 2 of the License, or
%   (at your option) any later version.
% 
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
% 
%   You should have received a copy of the GNU General Public License
%   along with this program; if not, write to the Free Software
%   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  

  %%% Check inputs argument
  if nargin>1
    error('too many input arguments');
  elseif nargin<1
    error('Not enough input argument');
  end;
  %%% Clear the previous solution if necessary
  quiz.feas='unsolved';
  for ii=1:quiz.ineq.nb
    quiz.ineq.meig{ii}=-Inf;
  end;
  for ii=1:quiz.eq.nb
    quiz.eq.mnorm{ii}=-Inf;
  end;
  quiz.obj.opt=[];
