function quiz = sdmpb(name,solvername)
% SDMPB - initialise a LMC problem (SDMPB object)
%   quiz = sdmpb(name,solvername) creates an empty problem and gives it a name
%   contained in the string <name>, solvername could be 'SeDuMi' (default)
%   or 'SDPT3'
%  
% SEE ALSO sdmvar, sdmlmi, sdmineq, sdmobj and sdmsol 
  
%   This file is part of SeDuMi Interface 1.04 (JUL2002)
%   Last Update 6th September 2002
%   Copyright (C) 2002 Dimitri Peaucelle & Krysten Taitz
%   LAAS-CNRS, Toulouse, France
% 
%   This program is free software; you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation; either version 2 of the License, or
%   (at your option) any later version.
% 
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
% 
%   You should have received a copy of the GNU General Public License
%   along with this program; if not, write to the Free Software
%   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
  
  if nargin==0
    name='NO NAME';
  end;
  if isa(name,'sdmpb');
    quiz=name;
  elseif ~isa(name,'char')
    error('the input argument must be a string');
  else
    quiz.name=name;
    quiz.var.nb=0;
    quiz.var.m=[];
    quiz.var.M=[];
    quiz.var.row=[];
    quiz.var.col=[];
    quiz.var.struc=[];
    quiz.var.strucconj=[];
    quiz.var.yinit=[];
    quiz.var.ysol=[];
    quiz.var.name=cell(1);
    quiz.var.set=cell(1);
    quiz.obj.bt=[];
    quiz.obj.btconj=[];
    quiz.obj.name=[];
    quiz.obj.opt=[];
    quiz.info=[];
    quiz.solvername = 'SeDuMi';
    quiz.feas='unsolved';
    quiz.ineq.nb=0;
    quiz.ineq.row=[];
    quiz.ineq.m=[];
    quiz.ineq.M=[];
    quiz.ineq.c=sparse(0,1);
    quiz.ineq.At=[];
    quiz.ineq.Atconj=[];
    quiz.ineq.blockm=cell(1);
    quiz.ineq.blockM=cell(1);
    quiz.ineq.name=cell(1);
    quiz.ineq.meig=cell(1);
    quiz.eq.nb=0;
    quiz.eq.row=[];
    quiz.eq.col=[];
    quiz.eq.m=[];
    quiz.eq.M=[];
    quiz.eq.c=sparse(0,1);
    quiz.eq.At=[];
    quiz.eq.Atconj=[];
    quiz.eq.blockmrow=cell(1);
    quiz.eq.blockMrow=cell(1);
    quiz.eq.blockmcol=cell(1);
    quiz.eq.blockMcol=cell(1);
    quiz.eq.name=cell(1);
    quiz.eq.mnorm=cell(1);
    quiz.K.s=[];
    quiz.K.ycomplex=[];
    quiz=class(quiz,'sdmpb');
  end;

  if nargin==2
    quiz.solvername = solvername;
  end;
  