function y = cone(Axplusb,cxplusd)
%CONE Defines a second order cone constraint ||z||<x
%
% Input
%    z       : column vector SDPVAR object.
%    h       : scalar double or SDPVAR object
%
% Example
%    F = set(cone(z,x)) 
%
% See also  SET, RCONE, @SDPVAR/NORM

% Author Johan Lfberg
% $Id: cone.m,v 1.3 2004/12/08 20:19:30 johanl Exp $

[n,m] = size(Axplusb);
if min(n,m)>1
    error('z must be a  vector')
end

if prod(size(cxplusd))>1
    error('x must be a scalar')
end

if n<m
    Axplusb = Axplusb';
end

try
    y = [cxplusd;Axplusb];
    if is(y,'linear')
        y.typeflag = 4;
    else
        y = (Axplusb'*Axplusb < cxplusd*cxplusd);
    end
catch
    error(lasterr)
end