function  LinearVariables = depends(x)
%DEPENDS Returns indicies to variables used in an SDPVAR object
%
% i = depends(x)
%
% Input
%    x : SDPVAR object
% Output
%    i : DOUBLE

% Author Johan Lfberg 
% $Id: depends.m,v 1.6 2005/01/05 10:05:03 johanl Exp $  

% FIX : SLOW, use code below, but that one fails for posynomials...
[mt,variabletype] = yalmip('monomtable');

% Simple linear cases
if ~any(variabletype(x.lmi_variables))
   LinearVariables = x.lmi_variables;
   return
end

LinearVariables = find(any(mt(x.lmi_variables,:),1));    
LinearVariables = LinearVariables(:)';

% Any extended variables
extended_variables =find(any(isnan(mt(x.lmi_variables,:)),1));
LinearVariables = unique([LinearVariables extended_variables(:)']);

%nlv = yalmip('nonlinearvariables')';
% Messy for nonlinear variables
%if  any(ismembc(x.lmi_variables,nlv(1,:))) %& ~isempty(nlv) 
%    mt = yalmip('monomtable');
%    LinearVariables = find(any(mt(x.lmi_variables,:),1));    
%    LinearVariables = LinearVariables(:)';
%else
%    LinearVariables = x.lmi_variables;
%end