function display(X)
%DISPLAY (overloaded)

% Author Johan Lfberg
% $Id: display.m,v 1.9 2005/01/10 15:46:17 johanl Exp $

switch(X.typeflag)
    case {0,9}
        n = X.n;
        m = X.m;
        if (n*m==1)

            if islinear(X)
                classification = 'Linear scalar ';
            elseif is(X,'sigmonial')
                classification = 'Sigmonial scalar ';
            elseif is(X,'bilinear')
                classification = 'Bilinear scalar ';
            elseif is(X,'quadratic')
                classification = 'Quadratic scalar ';
            else
                classification = 'Polynomial scalar ';
            end

            if ~isreal(X.basis)
                classification = [classification '(complex'];
            else
                classification = [classification '(real'];
            end

            if is(X,'compound')
                classification = [classification ', derived'];
            end

            if ~islinear(X)
                variables = getvariables(X);
                monomtable = yalmip('monomtable');
                if ((nnz(getbasematrix(X,0))==0) ) & (sum(diff(sum(monomtable(variables,:),2)))==0)
                    classification = [classification ', homogeneous'];
                end
            end
            if any(ismember(depends(X),yalmip('intvariables')))
                classification = [classification ', integer'];
            else
                if any(ismember(depends(X),yalmip('binvariables')))
                    classification = [classification ', binary'];
                else
                    if any(ismember(depends(X),yalmip('uncvariables')))
                        classification = [classification ', uncertain'];
                    end
                end
            end

            classification = [classification ', ' num2str(length(depends(X))) ' variables'];

            if any(ismember(depends(X),yalmip('parvariables')))
                classification = [classification ', parametric'];
            end
            if ~isnan(double(X))
                classification = [classification ', current value : ' num2str(double(X))];
            end
            classification = [classification ')'];

            disp([classification]);
        else

            if islinear(X)
                classification = 'Linear matrix variable ';
            elseif is(X,'sigmonial')
                classification = 'Sigmonial matrix variable ';
            elseif is(X,'bilinear')
                classification = 'Bilinear matrix variable ';
            elseif is(X,'quadratic')
                classification = 'Quadratic matrix variable ';
            else
                classification = 'Polynomial matrix variable ';
            end

            if isreal(X.basis)
                if issymmetric(X)
                    info = ' (symmetric, ';
                else
                    info = ' (full, ';
                end;
                info = [info 'real'];
            else
                if issymmetric(X)
                    info = ' (symmetric, ';
                elseif ishermitian(X)
                    info = ' (hermitian, ';
                else
                    info = ' (full, ';
                end;
                info = [info 'complex'];
            end;

            if is(X,'compound')
                info = [info ', derived'];
            end

            if X.typeflag==9
                info = [info ', KYP'];
            end
            if any(ismember(depends(X),yalmip('intvariables')))
                info = [info ', integer'];
            else
                if any(ismember(depends(X),yalmip('binvariables')))
                    info = [info ', binary'];
                else
                    if any(ismember(depends(X),yalmip('uncvariables')))
                        info = [info ', uncertain'];
                    end
                end
            end
            if any(ismember(depends(X),yalmip('parvariables')))
                info = [info ', parametric'];
            end
            
            x = recover(depends(X));
            info = [info ', ' num2str(length(x)) ' variables'];
            
            n = X.n;
            m = X.m;
            
            if ~any(any(isnan(double(x)))) & (n==m) & (n<100)
                doubleX = double(X);
                eigX = eig(doubleX);
                info = [info ', eigenvalues between [' num2str(min(eigX)) ',' num2str(max(eigX)) ']'];               
            end
          
            info = [info ')'];
            disp([classification num2str(n) 'x' num2str(m) info]);
        end;
    case 1
        disp('Relational object');
    case 3
        disp('Relational object');
    case 4
        disp('Relational object');
    case 5
        disp('Cone object');
    case 6
        disp('logdet object');
    case 7
        disp('Integrality constraint');
    case 10
        disp('Eigenvalue object');
    case 11
        disp('SOS object');
    otherwise
end