function issym=ishermitian(X)
%ISHERMITIAN Check if variable is Hermitian

% Author Johan Lfberg 
% $Id: ishermitian.m,v 1.2 2004/07/01 11:17:11 johanl Exp $  

n = X.n;
m = X.m;
issym = 0;
if (n==m)
    % What are the linear indicies to the transposed matrices
    ind = reshape(reshape(1:n^2,n,n)',n^2,1);
    X1 = X.basis;
    X2 = conj(X1(ind,:));
    issym = norm(X1-X2,1)<1e-10;
end
