function issym=issymmetric(X)
%ISSYMMETRIC Check if variable is symmetric

% Author Johan Lfberg 
% $Id: issymmetric.m,v 1.3 2005/01/10 09:14:44 johanl Exp $  

n = X.n;
m = X.m;
if (n==m)

    if 1
        % What are the linar indicies to the transposed matrices
        ind = reshape(reshape(1:n^2,n,n)',n^2,1);
        issym = norm(X.basis-X.basis(ind,:),1)<1e-10;
    else
        % Not 100%, but very unlikely to fail. Much faster...
        hash = rand(size(X.basis,2),1)+1;
        V = reshape(X.basis*hash,n,n);
        Vt = V.';Vt=Vt(:);
        V = V(:);
         try
            issym = norm(V-Vt,'inf')<1e-10;
         catch
            
        end
    end

else
    issym = 0;
end

