function sys = kyp(A,B,P,M)
%KYP Create KYP matrix variable
%
%   X = KYP(A,B,P,M)       
%
% KYP is used to generate the matrix
%
% [A'*P+P*A P*B;B'*P zeros(size(B,2))]+M;
%
% Note, Information is stored internally
% to inform YALMIP that this is a object
% defined from a KYP structure. Hence,
% the objects KYP(A,B,P,M) and the SDPVAR
% [A'*P+P*A P*B;B'*P zeros(size(B,2))]+M
% are not equivalent
%
%   See also LMI

% Author Johan Lfberg
% $Id: kyp.m,v 1.2 2004/07/01 11:17:11 johanl Exp $

kyp_part = [A'*P+P*A P*B;B'*P zeros(size(B,2))];
if isempty(kyp_part)
    sys = M;
else
    sys = kyp_part+M;
end
sys.typeflag = 9;
sys.extra.A = A;
sys.extra.B = B;
sys.extra.P = P;
sys.extra.M = M;
sys.extra.negated = 0;