function y=max(varargin)
%MAX (overloaded)
%
% t = min(x,y,z...) % Scalar SDPVAR arguments 
% t = min(X)        % Matrix SDPVAR arguments, see built-in min for details  
%
% Creates an internal structure relating the variable t
% with convex operator max(x,y,z,..).
%
% The variable t can only be used in convexity preserving
% operations such as t<0, min t etc.

% Author Johan Lfberg 
% $Id: max.m,v 1.5 2005/01/05 10:05:03 johanl Exp $

if nargin==1
    X = varargin{1};
    if min(size(X))==1
        if max(size(X))==1
            y = varargin{1};
        else
       %     for i = 1:length(X)
       %         inparg{i} = subsref(X,struct('type','()','subs',{{i}}));
       %     end           
            inparg{1} = X;
            y = yalmip('addextendedvariable','max',inparg{:});
        end
    else
        y = [];
        for i = 1:size(X,2)
            clear inparg;
            for j = 1:size(X,1)
                inparg{j} = subsref(X,struct('type','()','subs',{{j,i}}));
            end
            y = [y yalmip('addextendedvariable','max',inparg{:})];            
        end
    end   
else   
    y = yalmip('addextendedvariable','max',varargin{:});
end