function y = mpower(x,d)
%MPOWER (overloaded)

% Author Johan Lfberg
% $Id: mpower.m,v 1.6 2004/12/08 21:28:09 johanl Exp $

% Trivial cases
if d==0
    if x.n~=x.m
        error('Matrix must be square.')
    end
    y = eye(x.n,x.m)^0;
    return
end
if d==1
    y = x;
    return
end

% Fractional and negative powers 
if (ceil(d)-d>0) | (d<0)
    if x.n>1 | x.m>1
        error('Only scalars can have negative or non-integer powers');
    else
        base = getbase(x);
        if isequal(base,[0 1]) % Simple unit scalar
            mt = yalmip('monomtable');
            var = getvariables(x);
            %previous_var = find((mt(:,var)==d)  & (sum(mt~=0,2)==1));
            previous_var = findrows(mt,mt(var,:)*d);
            if isempty(previous_var)
                mt(end+1,:) = mt(getvariables(x),:)*d;
                yalmip('setmonomtable',mt);
                y = recover(size(mt,1));
            else
                y = recover(previous_var);
            end
        else % Bummer, something more complex, add an internal equality constraint 
            y = (yalmip('AddExtendedVariable','mpower',x))^d;           
        end
    end
    return
end

% Integer power of matrix
if x.n>1 | x.m>1
    switch d
        case 0
            y = 1;
        case 1
            y = x;
        otherwise
            y = x*mpower(x,d-1);
    end
else %Integer power of scalar
  
    base = x.basis;
    if isequal(base,[0 1]) % Unit scalar can be done fast
        mt = yalmip('monomtable');
        %var = getvariables(x);  
        var = x.lmi_variables;
        hash = randn(size(mt,2),1);
        mt_hash = mt*hash;
        previous_var = find(mt_hash == (d*mt(var,:))*hash);
      %  previous_var = find((mt(:,var)==d) & (sum(mt~=0,2)==1));
        if isempty(previous_var)
            mt(end+1,:) = mt(var,:)*d;
            yalmip('setmonomtable',mt);
            y = x;
            y.lmi_variables = size(mt,1);           
        else
            y = x;
            y.lmi_variables = previous_var;           
        end
    else % General scalar
        switch d
            case 0
                y = 1;
            case 1
                y = x;
            otherwise
                y = x*mpower(x,d-1);
        end
    end
end


