function [v,parvar] = sosd(X)
%SOSD Returns sum-of-squares decomposition
%
% Example
%
%  x = sdpvar(1,1);F = set(sos(1+x^2+x^4));solvesos(F);
%  polyprint(sosd(F))

if ~is(X,'sos')
    error('SOS decompositions are only available for SOS objects');
else
    [v,parvar] = yalmip('getsos',X.extra.sosid);    
end
