function y = vertcat(varargin)
%VERTCAT (overloaded)

% Author Johan Lfberg 
% $Id: vertcat.m,v 1.2 2004/07/01 11:17:14 johanl Exp $   

prenargin = nargin;
% Fast exit
if prenargin<2
    y=varargin{1};
    return
end

% Get dimensions
n = zeros(prenargin,1);
m = zeros(prenargin,1);
for i = 1:prenargin
    [n(i),m(i)]=size(varargin{i});
end

% Keep only non-empty
keep_these = find((n.*m)~=0);
if length(keep_these)<length(n)
    varargin = {varargin{keep_these}};
    n = n(keep_these);
    m = m(keep_these);
end;

% All widths should be equal
if any(m~=m(1))
    error('All rows in the bracketed expression must have the same number of columns.');
end

% Same code as for horzcat
for i = 1:length(varargin)
    dummy{i}=varargin{i}.';
end
y=stack(dummy).';