function [Fconv,changed] = convertlogics(F)

changed = 0;
Fconv = set([]);
% Loop over all ANDs
for i = 1:size(F.clauses,2)
    
    if size(F.clauses{i},2)>1 | is(F.clauses{i}{1}.data,'logic')
        % Definitely needs
        Fconv = Fconv + logic2cont(F.clauses{i});
        changed = 1;
    else
        Fconv.clauses{end+1}{1} = F.clauses{i}{1};       
    end
end



function Fcont = logic2cont(clauses)

M = 1e3;
% How many elements in this clause
n = length(clauses);

% Are all simple letters?
all_letters = 1;
j = 1;
while all_letters & j<=n
    if isa(clauses{j}.data,'sdpvar')
        all_letters = all_letters &  is(clauses{j}.data,'logic');
    else
        all_letters = 0;
    end
    j = j + 1;
end

Fcont = set([]);
if all_letters
    sum_or = 0;
    % Ah, simple constraints, just add them
    for j = 1:n
        sum_or = sum_or + clauses{j}.data;
    end
else
    % No, mix of letters and constraints, use big-M
    sum_or = 0;
    delta = binvar(size( clauses,2),1);
    for j = 1:length(clauses)
        if is(clauses{j}.data,'logic')
            sum_or = sum_or + clauses{j}.data;
        else
            delta = binvar(1,1);
            Fcont = Fcont + set(clauses{j}.data+M*(1-delta)>0);
            sum_or = sum_or + delta;
        end
    end
end
Fcont = Fcont + set(sum_or>1);










        %
        %
        %
        %
        %
        %
        %
        %
        %
        %
        %
        %
        %
        %
        % function F = logic2cont2(clauses)
        %
        % F = set([]);
        % M = 1e3;
        %
        % % How many elements in this clause
        % n = size(clauses,2);
        % % Are all simple letters?
        % all_letters = 1;
        % j = 1;
        % while all_letters & j<=n
        %     all_letters = all_letters &  isa(clauses{j}.data,'sdpvar');
        %     j = j + 1;
        % end
        %
        % if all_letters
        %     sum_or = 0;
        %     % Ah, simple constraints, just add them
        %     for j = 1:n
        %         sum_or = sum_or + x.clauses{i}{j};
        %     end
        %
        % else
        %     sum_or = 0;
        %     delta = binvar(size( x.clauses{i},2),1);
        %     for j = 1:size( x.clauses{i},2)
        %         clause_i_j = x.clauses{i}{j};
        %         if isa(clause_i_j,'constraint')
        %             delta = binvar(1,1);
        %             F = F + set(sdpvar(clause_i_j)+M*(1-delta)>0);
        %             sum_or = sum_or + delta;
        %         elseif isa(clause_i_j,'sdpvar')
        %             F = F + set(clause_i_j);
        %             sum_or = sum_or + clause_i_j;
        %         end
        %     end
        %
        % end
        % F = F + set(sum_or>1);
