function sys = display(X)
%display           Displays a SET object.

% Author Johan Lfberg
% $Id: display.m,v 1.4 2004/08/06 09:02:52 johanl Exp $

nlmi = size(X.clauses,2);

if (nlmi == 0)
    disp('empty SET')
    return
end

lmiinfo{1} = 'Matrix inequality';
lmiinfo{2} = 'Element-wise';
lmiinfo{3} = 'Equality constraint';
lmiinfo{4} = 'Second order cone constraint';
lmiinfo{5} = 'Rotated Lorentz constraint';
lmiinfo{7} = 'Integrality constraint';
lmiinfo{8} = 'Binary constraint';
lmiinfo{9} = 'KYP constraint';
lmiinfo{10}= 'Eigenvalue constraint';
lmiinfo{11}= 'Sum-of-square constraint';
lmiinfo{12}= 'Logic constraint';
lmiinfo{13}= 'Parametric definition';
lmiinfo{14}= 'Low-rank data declaration';

headers = {'ID','Constraint','Type','Tag'};
if nlmi>0
    for i = 1:nlmi
        data{i,1} = ['#' num2str(i)];
        data{i,2} = X.clauses{i}{1}.symbolic;
        data{i,3} = lmiinfo{X.clauses{i}{1}.type};

        if X.clauses{i}{1}.type == 14
        else
        if any(ismember(getvariables(X.clauses{i}{1}.data),yalmip('intvariables')))
            data{i,3} = [data{i,3} ' (integer)'];
        end
        
        if size(X.clauses{i},2)>1
            data{i,3} = [data{i,3} ' (logic)'];
        end
        classification = '';
        if ~islinear(X.clauses{i}{1}.data)
            if is(X.clauses{i}{1}.data,'sigmonial')
                classification = [classification 'sigmonial'];
            elseif is(X.clauses{i}{1}.data,'bilinear')
                classification = [classification 'bilinear'];
            elseif is(X.clauses{i}{1}.data,'quadratic')
                classification = [classification 'quadratic'];
            else
                classification = [classification 'polynomial'];
            end
            data{i,3} = [data{i,3} ' (' classification ')'];
        end

        data{i,4} = X.clauses{i}{1}.handle;
        if ~isreal(X.clauses{i}{1}.data)
            data{i,3} = [data{i,3} ' (complex)'];
        end
        
        if ismember(X.clauses{i}{1}.type,[1 2 3 4 5 9])
            data{i,3} = [data{i,3} ' ' num2str(size(X.clauses{i}{1}.data,1)) 'x' num2str(size(X.clauses{i}{1}.data,2))];
        end
        end

    end
end

% If no tags, don't show...
if length([data{:,4}])==0
    headers = {headers{:,1:3}};
    data = reshape({data{:,1:3}},length({data{:,1:3}})/3,3);
end


table('',headers,data)

function x= truncstring(x,n)
if length(x) > n
    x = [x(1:n-3) '...'];
end

function x = fillstring(x,n)
x = [x blanks(n-length(x))];

