function out = loadobj(obj)
%loadOBJ load filter for LMI objects.

% Restore persistent variables in SDPVAR class
if ~isempty(obj.savedata)
    try
        yalmip('setinternalsdpvarstate',obj.savedata.internalsdpvarstate);        
        yalmip('setinternalsetstate',obj.savedata.internalsetstate);
    catch
        error('Data probably saved in old YALMIP version. Cannot load this...');
    end
end
if ~isa(obj,'lmi'),
    out = class(obj,'lmi');
else
    out = obj;
end
out.savedata = [];