function p = polytope(X)
% polytope  Converts set object to polytope object        
%
% P     = polytope(F)
% [P,x] = polytope(F)
%
% P : polytope object (Requires the Multi-parametric Toolbox)
% x : sdpvar object defining the variables in the polytope P.H*x<P.K
% F : set-object with linear inequalities

% Author Johan Lfberg
% $Id: polytope.m,v 1.2 2004/07/19 13:54:36 johanl Exp $


if all(is(X,'element-wise'))% & all(is(X,'linear'))
    f = [];
    for i = 1:length(X)
        if  X.clauses{i}{1}.type==2
            fi =  X.clauses{i}{1}.data;
            f = [f;fi(:)];
        end
    end
    
    B = full(getbase(f));
    p = polytope(-B(:,2:end),B(:,1));
else
    error('polytope can only be applied to SET objects with linear inequalities.')
end