function sys = intvar(varargin)
%BINVAR Create symbolic binary variable 
%   
%   BINVAR works exactly as SDPVAR, with the only difference that
%   the elements in the variable automatically will be constrained 
%   to be binary (0/1) when an optimization problem is solved.
%
%   See also INTVAR, SDPVAR, BINARY, INTEGER

% Author Johan Lfberg
% $Id: binvar.m,v 1.4 2004/07/09 13:21:39 johanl Exp $

all_variable_names = 1;
i = 1;
while all_variable_names & i<=nargin
    all_variable_names = all_variable_names & isvarname(varargin{i});
    i = i + 1;
end
if all_variable_names
    for k = 1:nargin
        varname = varargin{k};
        assignin('caller',varname,binvar(1,1));
    end
else
    switch nargin
        case 1
            sys = sdpvar(varargin{1});
        case 2
            sys = sdpvar(varargin{1},varargin{2});
        case 3
            sys = sdpvar(varargin{1},varargin{2},varargin{3});
        case 4
            sys = sdpvar(varargin{1},varargin{2},varargin{3},varargin{4});
        otherwise
            error('Wrong number of input arguments. See help-text for sdpvar')
    end
    yalmip('setbinvariables',[yalmip('binvariables') getvariables(sys)]);
end