function [newton_m2,N_unique,newton_m2_unique] = monomialproducts(N);
%MONOMIALPRODUCTS  Internal function used for monomial reduction

% Author Johan Lfberg
% $Id: monomialproducts.m,v 1.2 2004/07/02 08:17:31 johanl Exp $

% Exponents in squared monomials
N_unique = [];
for i = 1:size(N,1)
    newton_m2{i} = [];
    n = size(N{i},1);
    for j = 1:n
        newton_m2{i} = [newton_m2{i};[(1:n)' repmat(j,n,1) N{i}(1:n,:)+repmat(N{i}(j,:),n,1)]];
    end
    % Whoops, double copies of diagonal (we want double copies of non-diagonals though)
    [dummy,j,dummy2] = unique(newton_m2{i}(:,1:2),'rows');
    newton_m2{i} = newton_m2{i}(j,:);
    % Extract unique monomial products
    [dummy,j,dummy2] = unique(newton_m2{i}(:,3:end),'rows');
    newton_m2_unique{i} = newton_m2{i}(j,:);
    
    N_unique = [N_unique;newton_m2_unique{i}];
   % [dummy,j,dummy2] = unique(N_unique(:,3:end),'rows');
   % N_unique = N_unique(j,:);
end
[dummy,j,dummy2] = unique(N_unique(:,3:end),'rows');
N_unique = N_unique(j,:);
