function [x_equ,H,A_equ,b_equ] = solveequalities(F_struc,K)
%SOLVEEQUALITIES Internal function remove equality constraints

% Author Johan Lfberg
% $Id: solveequalities.m,v 1.2 2004/07/02 08:17:32 johanl Exp $

% Extract the inequalities
A_equ = F_struc(1:K.f,2:end);
b_equ = -F_struc(1:K.f,1);
% Find feasible sing method from Nocedal-Wright book
[Q,R] = qr(A_equ');
n = max(find(sum(abs(R),2)));
Q1 = Q(:,1:n);
R = R(1:n,:);
x_equ = Q1*(R'\b_equ);  
H = Q(:,n+1:end); % New basis
