function [lb,ub] = tightenbounds(A,b,lb,ub,integer_variables);
%TIGHTENBOUNDS Internal function to perform bound tightening

% Author Johan Lfberg
% $Id: tightenbounds.m,v 1.2 2004/07/02 08:17:32 johanl Exp $

% Simple bound pre-processing (paper by Savelsbergh)
% No code optimization at all

ubnew = ub;
lbnew = lb;
goon = 1;

AL0A  = (A>0).*A;
AG0A  = (A<0).*A;
while goon
    
    bi_up = AL0A*ub+AG0A*lb;
    bi_dn = AL0A*lb+AG0A*ub;
    
    for i = 1:length(b)    
                
        Cp = find(A(i,:)>0);
        Cm = find(A(i,:)<0);
        
        for k = 1:length(Cp)
            ubnew(Cp(k)) = min(ub(Cp(k)),lb(Cp(k))+(b(i)-bi_dn(i))/A(i,Cp(k)));
        end
        for k = 1:length(Cm)
            lbnew(Cm(k)) = max(lb(Cm(k)),ub(Cm(k))+(b(i)-bi_dn(i))/A(i,Cm(k)));
        end         
        
    end
    lbnew(integer_variables) = fix(lbnew(integer_variables));
    ubnew(integer_variables) = fix(ubnew(integer_variables));
    goon = ~all((lb==lbnew) & (ub==ubnew));    
    lb = lbnew;
    ub = ubnew;
end